unit UQueue;

interface

type
  TElem = Integer;
  TList = ^TNode;
  TNode = record
    inf: TElem;
    next: TList;
  end;
  TQueue = record
    Head,Tail: TList;
  end;

procedure Init (var Q: TQueue); //
function IsEmpty (Q: TQueue): boolean; //  
procedure Push (var Q: TQueue; el: TElem); // 
function Pop (var Q: TQueue): TElem;// 
procedure Print (var Q: TQueue); // 

var Q: TQueue;

implementation

procedure Init;
begin
  Q.Head := nil
end;

function IsEmpty;
begin
  result := Q.Head = nil
end;

function Pop (var Q: TQueue): TElem;
var z: TList;
begin
if not IsEmpty (Q) then
     with Q do
      begin
        z := Head;
        result := z^.inf;
        Head := Head^.next;
        Dispose (z);
      end
end;

procedure Push;
var z: TList;
begin
  new (z);
  z^.inf := el;
  z^.next := nil;
  if IsEmpty (Q) then
    Q.Head := z
  else
    Q.Tail^.next := z;
  Q.Tail := z
end;


procedure Print (var Q: TQueue);
var El: TElem;
    temp: TQueue;
begin
  Init (temp);
  while not IsEmpty (Q) do
    begin
    El := Pop (Q);
    write (El, ' ');
    Push (temp,El);
    end;
  while not IsEmpty (temp) do
    begin
    El := Pop (temp);
    Push (Q,El);
    end;
  writeln;

end;

  

end.
