unit UQueue;

interface

type
  TData = Integer; // !- n1, n3
//TData = String;  // !- n2
  
  PNode = ^TNode;
  TNode = record
    Data: TData;
    Next: PNode;
  end;
  TQueue = record
    Head,Tail: PNode
  end;

procedure InitQueue (var X: TQueue);
function IsEmpty (var X: TQueue): Boolean;
procedure Push (var X: TQueue; const Value: TData);
function Pop (var X: TQueue): TData;
procedure DeleteQueue (var X: TQueue);

implementation

procedure InitQueue (var X: TQueue);
begin
  X.Head:=nil
end;

function IsEmpty (var X: TQueue): Boolean;
begin
  Result:=X.Head=nil
end;

procedure Push (var X: TQueue; const Value: TData);
var
  tmp: PNode;
begin
  New(tmp);
  with tmp^ do
  begin
    Data:=Value;
    Next:=nil;
  end;
  with X do
    if IsEmpty(X)
      then begin
        Head:=tmp;
        Tail:=tmp
      end
      else with Tail^ do
      begin
        Next:=tmp;
        Tail:=Next
      end
end;

function Pop (var X: TQueue): TData;
var
  tmp: PNode;
begin
  with X do
  begin
    tmp:=Head;
    with Head^ do
    begin
      Result:=Data;
      Head:=Next
    end
  end;
  Dispose(tmp);
end;

procedure DeleteQueue (var X: TQueue);
begin
  while not IsEmpty(X) do
    Pop(X)
end;

end.
