unit UStack;

interface

type
  TData = char;
  
  TStack = ^TNode;
  TNode = record
    Data: TData;
    Next: TStack
  end;

procedure InitStack (var Head: TStack);
function IsEmpty (var Head: TStack): Boolean;
procedure Push (var Head: TStack; const Value: TData);
function Pop (var Head: TStack): TData;
procedure DeleteStack (var Head: TStack);

implementation

procedure InitStack (var Head: TStack);
begin
  Head:=nil
end;

function IsEmpty (var Head: TStack): Boolean;
begin
  Result:=Head=nil
end;

procedure Push (var Head: TStack; const Value: TData);
var
  tmp: TStack;
begin
  New(tmp);
  with tmp^ do
  begin
    Data:=Value;
    Next:=Head
  end;
  Head:=tmp
end;

function Pop (var Head: TStack): TData;
var
  tmp: TStack;
begin
  tmp:=Head;
  with Head^ do
  begin
    Result:=Data;
    Head:=Next
  end;
  Dispose(tmp)
end;

procedure DeleteStack (var Head: TStack);
begin
  while not IsEmpty(Head) do
    Pop(Head)
end;

end.
